From 3a3804d022db3c883f0613327520140d5be726fb Mon Sep 17 00:00:00 2001
From: Daan De Meyer <daan.j.demeyer@gmail.com>
Date: Jan 20 2022 16:52:29 +0000
Subject: [PATCH 14/15] journal: Reduce space allocated for data, trie hash tables in compact mode


In compact mode, because we inline MESSAGE objects into the Entry object,
we end up fewer data objects per file, about 2/3 of the amount of entries
in a non-compact journal. Let's reduce the size of the data hash table
and trie hash table accordingly.

Number of data entries per file for system journal in compact mode:

/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-0000000000000001-0005cdd5d27d2d94.journal: 113311
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-000000000004962b-0005ce4384695cd4.journal: 102223
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-0000000000298d1a-0005cfadbe650a0c.journal: 93671
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-00000000002053b6-0005cf6655ddb579.journal: 90780
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-00000000001bb51b-0005cf3a84e7a3bd.journal: 89281
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-00000000000927c6-0005ce9eb78f1b15.journal: 85873
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-00000000000dd673-0005cece4242847b.journal: 84350
/home/daandemeyer/projects/systemd/tmp/copy.journal: 79482
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-0000000000127578-0005cef1afc242ec.journal: 77679
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-000000000024f770-0005cf8941801623.journal: 75602
/home/daandemeyer/projects/systemd/tmp/copy@d5f0b421e7264c3e9e4b10780029fcd0-0000000000171c33-0005cf15e3b8d49c.journal: 71032

Number of data entries per file for system journal in non-compact mode:

/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000001750b-0005ce128e01000b.journal: 155649
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000001dddfb-0005cf3dd5768f32.journal: 154270
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000024e2ea-0005cf78e9c5ae9a.journal: 154196
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000012095c-0005cee439c98426.journal: 153614
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000030e309-0005cfdf9cbf0ee7.journal: 153251
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000002e9274-0005cfc7147577e8.journal: 152944
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000000fa98f-0005ced350dafd2c.journal: 152311
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000062908-0005ce4caed15dcf.journal: 150689
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000203056-0005cf573dedbe4d.journal: 150480
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000333ab9-0005cfef9c957367.journal: 150430
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000146366-0005cef557e2d20d.journal: 150216
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000022805d-0005cf683e77bc0a.journal: 149996
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000002c2ebd-0005cfb62ab245c5.journal: 149568
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000016c06e-0005cf0785762604.journal: 149369
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000274ab8-0005cf8a01f4b69a.journal: 148248
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000029b8b2-0005cf9b05613234.journal: 147902
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000000d564d-0005cec1af9c5432.journal: 147346
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000003d58e-0005ce3afd8524e2.journal: 147255
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000000af51a-0005ceb0d3b90d23.journal: 146798
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000191537-0005cf196a6c4a8a.journal: 146645
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000001b844e-0005cf2bbc072bd5.journal: 146572
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000009bc02-0005ce9c95ee4584.journal: 83220
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system.journal: 69055
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-000000000008cbdc-0005ce5ecffdd340.journal: 66396
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000009c46-0005ce0e3abbf007.journal: 56187
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-0000000000000001-0005cdd5d27d2d94.journal: 54650
/var/log/journal/9bc4fc1fd8c442b9817cd6fd77e03de6/system@2d0a2848c14f4df79fd48b9649fb2256-00000000002c2686-0005cfb628639e9f.journal: 5636

Before:

SYSTEMD_JOURNAL_NON_INDEXED_FIELDS="_CAP_EFFECTIVE _PID _UID _GID _SELINUX_CONTEXT _SOURCE_REALTIME_TIMESTAMP _MACHINE_ID _HOSTNAME _STREAM_ID _LINE_BREAK SYSLOG_FACILITY SYSLOG_IDENTIFIER _COMM _CMDLINE _EXE _SYSTEMD_INVOCATION_ID"

OBJECT TYPE	 ENTRIES SIZE
Unused           0	 0B
Data             985433  92.3M
Field            2142    115.7K
Entry            3500812 614.4M
Data Hash Table  9	 32.0M
Field Hash Table 9	 46.9K
Entry Array	 240841  191.2M
Tag              0	 0B
Trie Node        1752652 66.8M
Trie Hash Table  9	 47.9M
Boot ID          55	 1.7K
Total            6481962 1.0G

After:

SYSTEMD_JOURNAL_NON_INDEXED_FIELDS="_CAP_EFFECTIVE _PID _UID _GID _SELINUX_CONTEXT _SOURCE_REALTIME_TIMESTAMP _MACHINE_ID _HOSTNAME _STREAM_ID _LINE_BREAK SYSLOG_FACILITY SYSLOG_IDENTIFIER _COMM _CMDLINE _EXE _SYSTEMD_INVOCATION_ID"

OBJECT TYPE      ENTRIES SIZE
Unused           0       0B
Data             980599  92.0M
Field            1948    105.2K
Entry            3501263 614.5M
Data Hash Table  8       18.9M
Field Hash Table 8       41.7K
Entry Array      238474  188.0M
Tag              0       0B
Trie Node        1753996 66.9M
Trie Hash Table  8       28.4M
Boot ID          53      1.6K
Total            6476357 1009.0M

---

diff --git a/src/libsystemd/sd-journal/journal-file.c b/src/libsystemd/sd-journal/journal-file.c
index 6333709..9cfe706 100644
--- a/src/libsystemd/sd-journal/journal-file.c
+++ b/src/libsystemd/sd-journal/journal-file.c
@@ -1037,13 +1037,15 @@ int journal_file_append_object(
 }
 
 static int default_data_hash_table_size(JournalFile *f) {
-        uint64_t s;
+        uint64_t s, d;
 
         /* We estimate that we need 1 hash table entry per 768 bytes of journal file and we want to make sure
          * we never get beyond 75% fill level. Calculate the hash table size for the maximum file size based
-         * on these metrics. */
+         * on these metrics. In compact, mode, we estimate we need 1 hash table entry per 1152 bytes of
+         * journal file. */
 
-        s = (f->metrics.max_size * 4 / 768 / 3) * sizeof(HashItem);
+        d = JOURNAL_HEADER_COMPACT(f->header) ? 1152 : 768;
+        s = (f->metrics.max_size * 4 / d / 3) * sizeof(HashItem);
         if (s < DEFAULT_DATA_HASH_TABLE_SIZE)
                 s = DEFAULT_DATA_HASH_TABLE_SIZE;
 

